From: Amir Goldstein <amir73il@gmail.com>
To: Eryu Guan <eguan@redhat.com>
Cc: Trond Myklebust <trondmy@primarydata.com>,
Jeff Layton <jlayton@poochiereds.net>,
"J . Bruce Fields" <bfields@fieldses.org>,
David Howells <dhowells@redhat.com>,
Miklos Szeredi <miklos@szeredi.hu>,
fstests@vger.kernel.org, linux-unionfs@vger.kernel.org
Subject: [PATCH v3 4/4] fstests: add generic test for file handles
Date: Thu, 20 Apr 2017 11:09:37 +0300 [thread overview]
Message-ID: <1492675777-27883-1-git-send-email-amir73il@gmail.com> (raw)
In-Reply-To: <1492619359-24763-5-git-send-email-amir73il@gmail.com>
Cloned from xfs specific test xfs/238, which checks
stale file handles of deleted files.
This test uses the generic open_by_handle_at() syscall
and also tests for non-stale file handles of linked files.
Signed-off-by: Amir Goldstein <amir73il@gmail.com>
---
tests/generic/426 | 76 +++++++++++++++++++++++++++++++++++++++++++++++++++
tests/generic/426.out | 2 ++
tests/generic/group | 1 +
3 files changed, 79 insertions(+)
create mode 100755 tests/generic/426
create mode 100644 tests/generic/426.out
Eryu,
Avoiding unneeded spam to the list,
here is a re-send of the last patch with your requested fixes.
Thanks,
Amir.
diff --git a/tests/generic/426 b/tests/generic/426
new file mode 100755
index 0000000..d2e555f
--- /dev/null
+++ b/tests/generic/426
@@ -0,0 +1,76 @@
+#! /bin/bash
+# FS QA Test No. 426
+#
+# Check stale handles pointing to unlinked files
+# and non-stale handles pointing to linked files
+#
+#-----------------------------------------------------------------------
+# Copyright (C) 2017 CTERA Networks. All Rights Reserved.
+# Author: Amir Goldstein <amir73il@gmail.com>
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs generic
+_supported_os Linux
+# _require_exportfs already requires open_by_handle, but let's not count on it
+_require_test_program "open_by_handle"
+_require_exportfs
+
+numfiles=1024
+testdir=$TEST_DIR/$seq-dir
+mkdir -p $testdir
+
+# Check stale handles to deleted files
+rm -f $testdir/*
+src/open_by_handle -c $testdir $numfiles
+src/open_by_handle -d $testdir $numfiles
+
+# Check non-stale handles to linked files
+rm -f $testdir/*
+src/open_by_handle -c $testdir $numfiles
+src/open_by_handle $testdir $numfiles
+
+# Check non-stale handles to files that were hardlinked and original deleted
+rm -f $testdir/*
+src/open_by_handle -c $testdir $numfiles
+src/open_by_handle -l $testdir $numfiles
+src/open_by_handle -u $testdir $numfiles
+
+echo "Silence is golden"
+status=0
+exit
diff --git a/tests/generic/426.out b/tests/generic/426.out
new file mode 100644
index 0000000..777cbcd
--- /dev/null
+++ b/tests/generic/426.out
@@ -0,0 +1,2 @@
+QA output created by 426
+Silence is golden
diff --git a/tests/generic/group b/tests/generic/group
index 6d6e4f6..f29009c 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -428,3 +428,4 @@
423 auto quick
424 auto quick
425 auto quick attr
+426 auto quick exportfs
--
2.7.4
prev parent reply other threads:[~2017-04-20 8:09 UTC|newest]
Thread overview: 11+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-04-19 16:29 [PATCH v2 0/4] fstests: generic test for NFS handles Amir Goldstein
2017-04-19 16:29 ` [PATCH v2 1/4] fstests: remove IRIX test program open_unlink Amir Goldstein
2017-04-19 16:29 ` [PATCH v2 2/4] src/open_by_handle: program to exercise open_by_handle_at() syscall Amir Goldstein
2017-04-22 7:55 ` Rock Lee
2017-04-19 16:29 ` [PATCH v2 3/4] src/open_by_handle: flexible usage options Amir Goldstein
2017-04-19 16:29 ` [PATCH v2 4/4] fstests: add generic test for file handles Amir Goldstein
2017-04-20 6:00 ` Eryu Guan
2017-04-20 6:34 ` Amir Goldstein
2017-04-20 7:21 ` Eryu Guan
2017-04-20 8:03 ` Amir Goldstein
2017-04-20 8:09 ` Amir Goldstein [this message]
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1492675777-27883-1-git-send-email-amir73il@gmail.com \
--to=amir73il@gmail.com \
--cc=bfields@fieldses.org \
--cc=dhowells@redhat.com \
--cc=eguan@redhat.com \
--cc=fstests@vger.kernel.org \
--cc=jlayton@poochiereds.net \
--cc=linux-unionfs@vger.kernel.org \
--cc=miklos@szeredi.hu \
--cc=trondmy@primarydata.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox